%Calcul des polynmes du N ieme polynome de zernicke  
function [Z_phase,Ampl_pupille]=phase_speckle(Ne,Rapport_plan_pupille,br_phase,rayon_correlation,gaussien)
%on passe Nbre d'echantillon, Rapport_plan_pupille

x=linspace(-Rapport_plan_pupille,Rapport_plan_pupille,Ne);
y=linspace(-Rapport_plan_pupille,Rapport_plan_pupille,Ne);
[X,Y]=meshgrid(x,y);

%R=sqrt(X.^2+Y.^2);
%A=atan2(Y,X);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Z=ones(size(X));

if (nargin==2),Z_phase=zeros(size(X));,end % cas idal
if (nargin==4),Z_phase=(rand(size(X))-0.5);,end %cas equirepartie (radians)
if (nargin==5),Z_phase=randn(size(X));,end %cas gaussien br_phase ecart type (radiand)


if (rayon_correlation~=0)
   h=fspecial('gaussian',rayon_correlation*5,rayon_correlation);
   Z_phase=filter2(h,Z_phase);
end

%mesure de sigma aprs filtrage
sigm_phase=std(reshape(Z_phase,Ne*Ne,1));
%br_phase (lambda -> radian)
br_phase=2*pi*br_phase;
%on veut sigma = br_phase
Z_phase=(br_phase/sigm_phase)*Z_phase;
%nouveau sigma
sigm_phase=std(reshape(Z_phase/(2*pi),Ne*Ne,1))




ihors_pupille=find((X.^2>1.001)|(Y.^2>1.001));
Z(ihors_pupille)=zeros(size(ihors_pupille));%masquage
masque=Z;
Z_phase=masque.*Z_phase;
%Z_phase=masque.*Z_phase;
Ampl_pupille=masque.*exp(i*Z_phase);
