%Calcul des polynmes du N ieme polynome de zernicke  
function [Z_phase,Ampl_pupille]=calc_phase_map(Ne,Rapport_plan_pupille,Zern)
%on passe Nbre d'echantillon, Rapport_plan_pupille
%Zern un tableau ligne de valeurs de  Zernicke
x=linspace(-Rapport_plan_pupille,Rapport_plan_pupille,Ne);
y=linspace(-Rapport_plan_pupille,Rapport_plan_pupille,Ne);
[X,Y]=meshgrid(x,y);
R=sqrt(X.^2+Y.^2);
A=atan2(Y,X);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Z=ones(size(R));
ihors_pupille=find(R>1.001);
Z(ihors_pupille)=zeros(size(ihors_pupille));%masquage
masque=Z;

%%%%%%%%%%%%%%%%%%%%%%


Nbre_de_Zern=size(Zern,2);
Z_phase=zeros(size(R));

for N=1:Nbre_de_Zern,
   if Zern(1,N)~=0
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      %tilt
      if N==2
         Z_phase=Z_phase+Zern(1,N)*R.*cos(A);
      end
      
      if N==3
         Z_phase=Z_phase+Zern(1,N)*R.*sin(A);
      end
      
      %defoc
      if N==4
         Z_phase=Z_phase+Zern(1,N)*(2*R.^2-1);
      end
      
      if N==5
         Z_phase=Z_phase+Zern(1,N)*R.^2.*cos(2*A);
      end
      
      %astig
      if N==6
         Z_phase=Z_phase+Zern(1,N)*R.^2.*sin(2*A);
      end
      
      if N==7
         Z_phase=Z_phase+Zern(1,N)*(3*R.^3-2.*R).*cos(A);
      end
      
      if N==8
         Z_phase=Z_phase+Zern(1,N)*(3*R.^3-2.*R).*sin(A);
      end
      
      
      if N==9
         Z_phase=Z_phase+Zern(1,N)*(6*R.^4-6*R.^2+1);
      end
      
      
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      
      if N==10
         Z_phase=Z_phase+Zern(1,N)*R.^3.*cos(3*A);
      end
      
      
      if N==11
         Z_phase=Z_phase+Zern(1,N)*R.^3.*sin(3*A);
      end
      
      if N==12
         Z_phase=Z_phase+Zern(1,N)*(4*R.^4-3.*R.^2).*cos(2*A);
      end
      
      if N==13
         Z_phase=Z_phase+Zern(1,N)*(4*R.^4-3.*R.^2).*sin(2*A);
      end
      
      if N==14
         Z_phase=Z_phase+Zern(1,N)*(10*R.^5-12.*R.^3+3*R).*cos(A);
      end
      
      if N==15
         Z_phase=Z_phase+Zern(1,N)*(10*R.^5-12.*R.^3+3*R).*sin(A);
      end
      
      if N==16
         Z_phase=Z_phase+Zern(1,N)*(20*R.^6-30*R.^4+12*R.^2-1);
      end
      
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
      
      
      
      
      if N==17
         Z_phase=Z_phase+Zern(1,N)*R.^4.*cos(4*A);
      end
      
      
      if N==18
         Z_phase=Z_phase+Zern(1,N)*R.^4.*sin(4*A);
      end
      
      if N==19
         Z_phase=Z_phase+Zern(1,N)*(5*R.^5-4.*R.^3).*cos(3*A);
      end
      
      if N==20
         Z_phase=Z_phase+Zern(1,N)*(5*R.^5-4.*R.^3).*sin(3*A);
      end
      
      if N==21
         Z_phase=Z_phase+Zern(1,N)*(15.*R.^6-20.*R.^4+6.*R.^2).*cos(2*A);
      end
      
      if N==22
         Z_phase=Z_phase+Zern(1,N)*(15.*R.^6-20.*R.^4+6.*R.^2).*sin(2*A);
      end
      
      if N==23
         Z_phase=Z_phase+Zern(1,N)*(35.*R.^7-60.*R.^5+30.*R.^3-4.*R).*cos(A);
      end
      
      
      if N==24
         Z_phase=Z_phase+Zern(1,N)*(35.*R.^7-60.*R.^5+30.*R.^3-4.*R).*sin(A);
      end
      
      if N==25
         Z_phase=Z_phase+Zern(1,N)*(70.*R.^8-140*R.^6+90*R.^4+20.*R.^2+1);
      end
      
      if N==26
         Z_phase=Z_phase+Zern(1,N)*R.^5.*cos(5*A);
      end
      
      if N==27
         Z_phase=Z_phase+Zern(1,N)*R.^5.*sin(5*A);
      end
      
      if N==28
         Z_phase=Z_phase+Zern(1,N)*(6*R.^2-5).*cos(4*A);
      end
      
      if N==29
         Z_phase=Z_phase+Zern(1,N)*(6*R.^2-5).*sin(4*A);
      end	
      
      if N==30
         Z_phase=Z_phase+Zern(1,N)*(21*R.^4-30*R.^2+10).*cos(3*A);
      end
      
      if N==31
         Z_phase=Z_phase+Zern(1,N)*(21*R.^4-30*R.^2+10).*sin(3*A);
      end
      
      if N==32
         Z_phase=Z_phase+Zern(1,N)*(56*R.^6-105*R.^4+60*R.^2-10).*cos(2*A);
      end
      
      if N==33
         Z_phase=Z_phase+Zern(1,N)*(56*R.^6-105*R.^4+60*R.^2-10).*sin(2*A);
      end
      
      if N==34
         Z_phase=Z_phase+Zern(1,N)*(126*R.^8-280*R.^6+210*R.^4-60*R.^2+5).*R.*cos(A);
      end
      
      if N==35
         Z_phase=Z_phase+Zern(1,N)*(126*R.^8-280*R.^6+210*R.^4-60*R.^2+5).*R.*sin(A);
      end
      
      if N==36
         Z_phase=Z_phase+Zern(1,N)*(252.*R.^10-630*R.^8+560*R.^6-210*R.^4+30*R.^2-1);
      end
      
      if N==37
         Z_phase=Z_phase+Zern(1,N)*(924.*R.^12-2772.*R.^10+3150*R.^8-1680*R.^6+420*R.^4-42*R.^2+1);
      end
      
      
   end %du premier if
end %du for
Z_phase=masque.*Z_phase;
Ampl_pupille=masque.*exp(2*i*pi*Z_phase);
